/*
		ImprovedEdit.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Class for all strings to use, instead of CEdit.  Context window for formatting & color.	
*/
#include "stdafx.h"
#include "Cbreak.h"
#include "ImprovedEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ImprovedEdit

ImprovedEdit::ImprovedEdit()
{
}

ImprovedEdit::~ImprovedEdit()
{
}


BEGIN_MESSAGE_MAP(ImprovedEdit, CEdit)
	//{{AFX_MSG_MAP(ImprovedEdit)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
  ON_COMMAND_RANGE(ID_IMPROVEDEDIT_FORMAT, ID_IMPROVEDEDIT_FORMATI, OnImprovededitFormat)
  ON_COMMAND(ID_EDIT_UNDO, OnUndo)
  ON_COMMAND(ID_EDIT_CUT, OnCut)
	ON_COMMAND(ID_EDIT_PASTE, OnPaste)
  ON_COMMAND(ID_EDIT_COPY, OnCopy)
	ON_COMMAND(ID_EDIT_CLEAR, OnClear)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnSelectAll)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ImprovedEdit message handlers

void ImprovedEdit::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	UINT test;

  int beg,end;

	if(point.x == -1 && point.y == -1) {
		CRect rect;
		GetClientRect(&rect);
		point=rect.TopLeft();
		point.Offset(5,5);
		ClientToScreen(&point);
	}

	CMenu mnuTop;
	//mnuTop.LoadMenu(IDR_EDIT_RIGHT);

	//CMenu *pPopup = mnuTop.GetSubMenu(0);
	
	mnuTop.LoadMenu(IDR_MAINFRAME);
	CMenu *pPopup = mnuTop.GetSubMenu(1);

	/* check to see what's enabled or not ..*/

	/* can undo? */
	test=(CanUndo() ? 0 : MF_GRAYED);
	pPopup->EnableMenuItem(ID_EDIT_UNDO, MF_BYCOMMAND | test);
  
	/* there's a selection? */
	GetSel(beg,end);
	test=((beg!=end) ? 0 : MF_GRAYED);
	pPopup->EnableMenuItem(ID_EDIT_CUT,MF_BYCOMMAND|test);
	pPopup->EnableMenuItem(ID_EDIT_COPY,MF_BYCOMMAND|test);
	pPopup->EnableMenuItem(ID_EDIT_CLEAR,MF_BYCOMMAND|test);
	/* these two always available if it's an improved edit */
  //  pPopup->EnableMenuItem(ID_IMPROVEDEDIT_FORMAT,MF_BYCOMMAND|test);
  //  pPopup->EnableMenuItem(ID_IMPROVEDEDIT_FORMATI,MF_BYCOMMAND|test);

  /* clipboard info? */
	test = (::IsClipboardFormatAvailable(CF_TEXT) ? 0 : MF_GRAYED);
	pPopup->EnableMenuItem(ID_EDIT_PASTE,MF_BYCOMMAND|test);

	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON,
		point.x, point.y, this, NULL);
    pPopup->DestroyMenu();

}

void ImprovedEdit::OnImprovededitFormat(UINT nId) 
{
  string temp,temp2,temp3;
  CString crap;			/* stupid msvc fagging things up */
  int count;
  
  /* first, we'll just format everything - later, we should do it by selection*/

  GetWindowText(crap);
  temp=crap;

  /* remove all non-space whitespace, hard or soft or whatever */

  while(temp.find("\r") != -1) {
	  temp.replace(temp.find("\r"),1," ");
  }

  while(temp.find("\n") != -1) {
	  temp.replace(temp.find("\n"),1," ");
  }

  while(temp.find("\t") != -1) {
	  temp.replace(temp.find("\t"),1," ");
  }

  while(temp.find("  ") != -1) {
	  temp.replace(temp.find("  "),2," ");
  }

  /* word by word, i suppose. */

  count=0; 
	if (nId == ID_IMPROVEDEDIT_FORMATI) {
		count += 4;
		temp3 = "    ";
  }
  while(temp.find(" ") != -1) {
    temp2=temp.substr(0,temp.find(" "));
	  temp=temp.substr(temp.find(" ")+1);
    if(count + temp2.size() > 80) {
			/* have to back up one space if we can */
			if(temp3.size() > 0) {
				temp3.resize(temp3.size() - 1);
			}
			temp3 += "\r\n";
			temp3 += temp2;
			temp3 += " ";
			count = temp2.size() +1;
		} else {
			count += temp2.size() + 1;
			temp3 += temp2;
			temp3 += " ";
		}
  }
	/* have to add the last word! */
	if(temp.size() + count > 80) {
		temp3 +="\r\n";
	}
	temp3 += temp;
  
  SetWindowText(iprintf("%s",temp3.c_str()));
 
}




